#include <xc.h>

//basic configuration of PIC16F1847
#pragma config FOSC=INTOSC,WDTE=OFF,PWRTE=OFF,MCLRE=OFF,CP=OFF,CPD=OFF,BOREN=ON,CLKOUTEN=OFF,IESO=OFF,FCMEN=OFF
#pragma config WRT=OFF,PLLEN=OFF,STVREN=ON,BORV=LO,LVP=OFF

#define  RX_LEFT_BLACK        PORTAbits.RA3==1
#define  RX_LEFT_WHITE        PORTAbits.RA3==0
#define  RX_CENTRE_BLACK      PORTAbits.RA2==1
#define  RX_CENTRE_WHITE      PORTAbits.RA2==0
#define  RX_FRONT_BLACK       PORTAbits.RA1==1
#define  RX_FRONT_WHITE       PORTAbits.RA1==0
#define  RX_RIGHT_BLACK       PORTAbits.RA0==1
#define  RX_RIGHT_WHITE       PORTAbits.RA0==0
// Vbat RA4
#define  BUTTON_ON            PORTAbits.RA5==0
#define  BUTTON_OFF           PORTAbits.RA5==1
#define  RGB_G_ON             LATAbits.LATA6=1
#define  RGB_G_OFF            LATAbits.LATA6=0
#define  PWM_A                LATAbits.LATA7

#define  INFRA                PORTBbits.RB0
#define  IN1                  LATBbits.LATB1
#define  IN2                  LATBbits.LATB2
#define  PWM_B                LATBbits.LATB3
#define  IN4                  LATBbits.LATB4
#define  IN3                  LATBbits.LATB5
#define  RGB_R_ON             LATBbits.LATB6=1
#define  RGB_R_OFF            LATBbits.LATB6=0
#define  RGB_B_ON             LATBbits.LATB7=1
#define  RGB_B_OFF            LATBbits.LATB7=0

#define  RED                  {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;RGB_R_ON;RGB_B_OFF;RGB_G_OFF;}
#define  BLUE                 {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;RGB_R_OFF;RGB_B_ON;RGB_G_OFF;}
#define  GREEN                {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;RGB_R_OFF;RGB_B_OFF;RGB_G_ON;}
#define  LED_OFF              {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;}
#define  PURPLE               {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;RGB_R_ON;RGB_B_ON;RGB_G_OFF;}
#define  ORANGE               {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;RGB_R_ON;RGB_B_OFF;RGB_G_ON;}
#define  MIX                  {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;RGB_R_ON;RGB_B_ON;RGB_G_ON;}
#define  BLUEGREEN            {RGB_R_OFF;RGB_B_OFF;RGB_G_OFF;RGB_R_OFF;RGB_B_ON;RGB_G_ON;}

#define _XTAL_FREQ           16000000


unsigned int i,ii,Last_RX=0,power,cycleno=0,LNO=0,RNO=0;
unsigned long cas, Vbat=0,TMR0overflow=0,RXC=0,RXR=0,RXL=0,RXOUT=0,RXLC=0,RXRC=0,Dist=0;

void Wait(long ms);
void PIC_Init();
void BATTERY();
void DISTANCE();
void MOTORS(int powerL,int powerR);
void interrupt Inter();

void PIC_Init()
{
     TRISA=0b00111111; TRISB=0b00000001;// setting inputs=1/outputs=0
     ANSELA=0b00010000; ANSELB=0b00000000;// setting analog=1/digital=0 inputs
     LATA=0; LATB=0;               // zeroing outputs
      
     OPTION_REG=0b00000111;         // enabling pull-ups
     WPUAbits.WPUA5=1;    // pull-up at a button

     OSCCON=0b01111010;	   // 16 MHz internal oscillator
    INTCONbits.GIE=1;
    INTCONbits.TMR0IE=1;
    INTCONbits.TMR0IF=0;
         
     
     APFCON0bits.CCP1SEL=0; // PWM CCP1 at RB3
     APFCON0bits.CCP2SEL=1; // PWM CCP2 at RA7

     
    //setting PWM at RB3 and RA7, PWM frequency = 244 Hz
        TRISBbits.TRISB3=1;
	PR2=255;
	CCP1CON=0b00001100;
	CCPR1L=0;
	PIR1bits.TMR2IF=0;
	T2CON=0b00000111;   // prescaler 64
	TRISBbits.TRISB3=0;
        
        TRISAbits.TRISA7=1;
	PR4=255;
	CCP2CON=0b00001100;
	CCPR2L=0;
	PIR3bits.TMR4IF=0;
	T2CON=0b00000111;   // prescaler 64
	TRISAbits.TRISA7=0;

   // setting A/D converter
        ADCON1=0b10100000; // right adjusted, conversion freq. FOSC/32, VDD reference
        ADCON0=0b00010001; // ADC at channel RA4=AN4, ADC module on
}



void main()
{
    PIC_Init();
    
    BATTERY();
    for(int i=0;i<2;i++)
    {
        if(Vbat<410)  {LED_OFF;RED;}     //<5.6 V
        if(Vbat>=410) {LED_OFF;PURPLE;}  // 5.6 - 6.0 V
        if(Vbat>=440) {LED_OFF;ORANGE;}     // 6.0 - 6.4 V
        if(Vbat>=469) {LED_OFF;MIX;}    // 6.4 - 6.8 V
        if(Vbat>=498) {LED_OFF;BLUE;}  // 6.8 - 7.2 V
        if(Vbat>=528) {LED_OFF;BLUEGREEN;}  // 7.2 - 7.6 V
        if(Vbat>=557) {LED_OFF;GREEN;}   // >7.6 V

        Wait(100);LED_OFF;Wait(50);
    }
 
 

  while(1)
  {
     DISTANCE();
     if(Dist>=200)
     { ORANGE;
       
        MOTORS(-75,-75);
         while(Dist>=200) DISTANCE();
      //   MOTORS(0,0);Wait(2000);
   
      MOTORS(100,-100);Wait(200);
    //  MOTORS(0,0);Wait(2000);
      MOTORS(100,100);Wait(250);
   //   MOTORS(0,0);Wait(2000);
      MOTORS(0,80);
  //  Wait(400);
  //  MOTORS(75,75);
      while(RX_CENTRE_WHITE && RX_LEFT_WHITE && RX_RIGHT_WHITE);
     }


   if(RX_LEFT_BLACK && RX_CENTRE_WHITE && RX_RIGHT_WHITE) RXL++;
   if(RX_RIGHT_BLACK && RX_CENTRE_WHITE && RX_LEFT_WHITE) RXR++;
   if(RX_CENTRE_BLACK && RX_LEFT_WHITE && RX_RIGHT_WHITE) RXC++;
   if(RX_CENTRE_WHITE && RX_LEFT_WHITE && RX_RIGHT_WHITE) RXOUT++;
   if(RX_CENTRE_BLACK && RX_LEFT_BLACK && RX_RIGHT_WHITE) RXLC++;
   if(RX_CENTRE_BLACK && RX_LEFT_WHITE && RX_RIGHT_BLACK) RXRC++;
   cycleno++;
    
   if(BUTTON_ON) {MOTORS(0,0);PURPLE}
  // else if(RX_FRONT_WHITE) {MOTORS(-100,-100);ORANGE;Wait(100);MOTORS(0,0);Wait(3000);}
   else if(RX_CENTRE_BLACK){MOTORS(100,100);GREEN}
 //  else if(RX_CENTRE_BLACK && RX_LEFT_BLACK){MOTORS(-100,100);ORANGE}
 //  else if(RX_CENTRE_BLACK && RX_RIGHT_BLACK){MOTORS(100,-100);BLUEGREEN}
   else if(RX_RIGHT_BLACK) {MOTORS(100,-100);RED}                           
   else if(RX_LEFT_BLACK){MOTORS(-100,100);BLUE}
   else {MOTORS(-100,-100);MIX}
   

   if(cycleno>1000)
   {
      if(RXOUT>200 && RXC>200)
            {MOTORS(100,100);BLUEGREEN;Wait(450);TMR0overflow=0;MOTORS(75,-75);while(RX_RIGHT_WHITE && RX_LEFT_WHITE && RX_CENTRE_WHITE && TMR0overflow<25);
            if(TMR0overflow>=25) {TMR0overflow=0;MOTORS(-75,75);while(RX_RIGHT_WHITE && RX_LEFT_WHITE && RX_CENTRE_WHITE && TMR0overflow<70);}
            if(TMR0overflow>=70) {TMR0overflow=0;MOTORS(100,100);while(RX_RIGHT_WHITE && RX_LEFT_WHITE && RX_CENTRE_WHITE);}
            }
      else if(RXOUT>400 && RXLC>400 ){BLUE;MOTORS(-100,100);Wait(50);}
      else if(RXOUT>400 && RXRC>400 ){RED;MOTORS(100,-100);Wait(50);}
      RXOUT=0;RXL=0;RXR=0;RXC=0;cycleno=0;
   }
           
   }
}


void MOTORS(int powerL,int powerR)
{
     if(Vbat<498) Vbat=498;
     CCPR2L=(powerL*126990)/(100*Vbat);
     CCPR1L=(powerR*126990)/(100*Vbat);
 
    if(powerL<0) {IN1=1;IN2=0;CCPR2L=(-powerL*126990)/(100*Vbat);}
    if(powerL>=0) {IN1=0;IN2=1;CCPR2L=(powerL*126990)/(100*Vbat);}
  //  if(powerL==0) {IN1=0;IN2=0;PWM_A=0;}
    if(powerR<0) {IN3=1;IN4=0;CCPR1L=(-powerR*126990)/(100*Vbat);}
    if(powerR>=0) {IN3=0;IN4=1;CCPR1L=(powerR*126990)/(100*Vbat);}
  //  if(powerR==0) {IN3=0;IN4=1;;PWM_B=0;}


}


void Wait(long ms)
{
    for(long bb=0;bb<ms;bb++) __delay_ms(1);;
}


void BATTERY()
{
    Vbat=0;
    for(int i=0;i<100;i++)
    {
  	ADCON0=0b00010011; // ADC conversion go
    	while(ADCON0==0b00010011); // waiting for conversion
        Vbat+=ADRES;
    }
        Vbat=Vbat/100;
}

void DISTANCE()
{
    Dist=0;
    for(int i=0;i<100;i++)
    {
  	ADCON0=0b00000111; // ADC conversion go
    	while(ADCON0==0b00000111); // waiting for conversion
        Dist+=ADRES;
    }
        Dist=Dist/100;
}



void interrupt Inter()
{
    TMR0overflow++;
    INTCONbits.TMR0IF=0;
    
          
}
        